/**************************************************************************** 
*  i2c.c
*
*  Gergely Zaruba
*  August 2007
*
****************************************************************************/
#include "i2c.h"

char I2C_Write_string(char p_addr)
{
  I2C_bfr_ptr=0; //set transmission counter to 0
  I2C_error = false;
  I2C_block = true;

  I2CNDAT = I2C_nr_bytes;  // transmit this many bytes
  I2CSA = p_addr;    // Slave address

  U0CTL &= ~I2CEN; // disable I2C  see errata I2C11
  U0CTL |= I2CEN; // enable I2C


  U0CTL |= MST;  // Master
  I2CTCTL |= I2CSTT + I2CSTP + I2CTRX; // Start transmission 
                                       //(stop condition is automatically generated)
  P2OUT = 0xFF;
  while(I2C_block);
  return I2C_error;
}

char I2C_Read_string(char p_addr) //blocking 
{
  I2C_bfr_ptr=0; //set reception counter to 0
  I2C_error = false;
  I2C_block = true;

  I2CNDAT = I2C_nr_bytes;  // receive this many bytes
  I2CSA = p_addr;    // Slave address
  U0CTL |= MST;  // Master

  U0CTL &= ~I2CEN; // disable I2C  see errata I2C11
  U0CTL |= I2CEN; // enable I2C

  I2CTCTL &= ~ I2CTRX;
  I2CTCTL |= I2CSTT + I2CSTP; // Start transmission 
                              //(stop condition is automatically generated)
  while(I2C_block);
  return I2C_error;
}
